
// I_SOUND.C

#include <stdio.h>
#include <dsound.h>
#include <mmreg.h>
#include <crtdbg.h>
#include <assert.h>
#include <windowsx.h>
#define __BYTEBOOL__
#include "h2def.h"
#include "sounds.h"
#include "soundst.h"
#include "SFXInfo.h"
#include "i_sound.h"

// DIVIDE a Hexen angle (which ranges from 0 to 2^32) by this
// value to convert it to Radians (ranging from 0 to 2*PI)...
//
#define HEXENANGLES_TO_RADIANS	683565275.6

#if 0

typedef struct _MUSFile
{
	char	m_rgbID[4];
	WORD	m_wcbMusicData;
	WORD	m_wcbHeaderData;
	WORD	m_wcPrimaryChannels;
	WORD	m_wcSecondaryChannels;
	WORD	m_wcPatches;
	WORD	m_wReserved;
	WORD *	m_rgwPatches;
	BYTE *	m_rgbMusicData;
} MUSFile;

#pragma pack(push, 1)

typedef struct __MUSEvent
{
	BYTE	m_bChannel	: 4;
	BYTE	m_bEventType: 3;
	BYTE	m_bLast		: 1;
} _MUSEvent;

typedef union MUSEvent
{
	BYTE		m_bEvent;
	_MUSEvent	m_event;
} MUSEvent;

#pragma pack(pop)

typedef struct _MUS2MIDIState
{
	MUSFile			m_mf;
	BYTE *			m_pCurMUSEvent;
	DWORD *			m_rgmidEvents;
	DWORD *			m_pCurMIDEvent;
	DWORD			m_dwcBufferDWORDs;
	BYTE			m_rgbChannelVolume[16];
	LONG			m_lNextWaitTime;
#ifdef _DEBUG
	char			m_szCurrentOperation[256];
#endif
} MUS2MIDIState;

typedef struct _MIDIState
{
	MIDIHDR *		m_rgMidiHdr;
	DWORD **		m_rgpBuffer;
	DWORD *			m_rgdwcBufferLength;
	DWORD			m_dwcBuffers;
	DWORD			m_dwiCurrentBuffer;
	BOOL			m_fLooping;
	BOOL			m_fDontPlay;
} MIDIState;


static void WriteShortMIDIMessage(DWORD **ppCurMIDEvent, LONG lWait, BYTE bStatus, BYTE bData1, BYTE bData2);
static void HandleKeyUp(MUSEvent *pevt, MUS2MIDIState *pM2M);
static void HandleKeyDown(MUSEvent *pevt, MUS2MIDIState *pM2M);
static void HandlePitchBend(MUSEvent *pevt, MUS2MIDIState *pM2M);
static void HandleSystemEvent(MUSEvent *pevt, MUS2MIDIState *pM2M);
static void HandleControllerEvent(MUSEvent *pevt, MUS2MIDIState *pM2M);
static void ConvertMUSEventsToMIDIEvents(MUS2MIDIState *pM2M);

#endif	// 0

HRESULT I_InitMusic(IDirectSound *);
void I_ShutdownMusic(void);

extern sfxinfo_t S_sfx[];
extern HWND g_hWnd;

/*
===============
=
= I_StartupTimer
=
===============
*/

//int tsm_ID = -1;

static IDirectSound *g_pDS = NULL;
static IDirectSound3DListener *g_pDS3DL = NULL;
static boolean g_fUseHardwareMixing;
static DWORD g_dwAvailHWBuffers;
static DWORD g_dwAvailHWBytes;

/*
void I_StartupTimer (void)
{
	// SND_TODO:
#ifndef NOTIMER
	extern int I_TimerISR(void);

	ST_Message("  I_StartupTimer()\n");
	// installs master timer.  Must be done before StartupTimer()!
	TSM_Install(SND_TICRATE);
	tsm_ID = TSM_NewService (I_TimerISR, 35, 255, 0); // max priority
	if (tsm_ID == -1)
	{
		I_Error("Can't register 35 Hz timer w/ DMX library");
	}
#endif
}

void I_ShutdownTimer (void)
{
	// SND_TODO:
//	TSM_DelService(tsm_ID);
//	TSM_Remove();
}
*/

/*
 *
 *                           SOUND HEADER & DATA
 *
 *
 */

// sound information
#if 0
const char *dnames[] = {"None",
			"PC_Speaker",
			"Adlib",
			"Sound_Blaster",
			"ProAudio_Spectrum16",
			"Gravis_Ultrasound",
			"MPU",
			"AWE32"
			};
#endif

const char snd_prefixen[] = { 'P', 'P', 'A', 'S', 'S', 'S', 'M',
  'M', 'M', 'S' };

int snd_Channels;
int snd_DesiredMusicDevice, snd_DesiredSfxDevice;
int snd_MusicDevice,    // current music card # (index to dmxCodes)
	snd_SfxDevice,      // current sfx card # (index to dmxCodes)
	snd_MaxVolume,      // maximum volume for sound
	snd_MusicVolume;    // maximum volume for music
//int dmxCodes[NUM_SCARDS]; // the dmx code for a given card

int     snd_SBport, snd_SBirq, snd_SBdma;       // sound blaster variables
int     snd_Mport;                              // midi variables

extern boolean  snd_MusicAvail, // whether music is available
		snd_SfxAvail;   // whether sfx are available
extern boolean forcesound;
extern boolean nods3d;
extern angle_t		viewangle;
extern byte *SoundCurve;

angle_t R_PointToAngle2 (fixed_t x1, fixed_t y1, fixed_t x2, fixed_t y2);



// Old, midiOut-style code...
//
#if 0

static MIDIState g_MidiState;
static MUS2MIDIState g_M2M;
static HMIDISTRM g_hMidiStrm = NULL;
static boolean g_fPlayMusic = true;


void I_HandleMusicDoneEvent(HMIDIOUT hmo, MIDIHDR *pmh)
{
	MIDIState *pms = &g_MidiState;

	if(hmo && pmh)
	{
		if(pms->m_fDontPlay == FALSE)
		{
			// Immediately start playing the next chunk...
			//
			pms->m_dwiCurrentBuffer += 1;

			if(pms->m_dwiCurrentBuffer < pms->m_dwcBuffers)
			{
				midiStreamOut((HMIDISTRM)hmo, &pms->m_rgMidiHdr[pms->m_dwiCurrentBuffer], sizeof(MIDIHDR));
			}
			else if(pms->m_fLooping)
			{
				pms->m_dwiCurrentBuffer = 0;
				midiStreamOut((HMIDISTRM)hmo, &pms->m_rgMidiHdr[0], sizeof(MIDIHDR));
			}
		}
	}
}


void I_PauseSong(int handle)
{
	HMIDISTRM hms = (HMIDISTRM)handle;
	MMRESULT mmr;

	if(!g_fPlayMusic || !g_hMidiStrm || !handle)
		return;

	mmr = midiStreamPause(g_hMidiStrm);

/*
	if((mmr = midiStreamPause(g_hMidiStrm)) != MMSYSERR_NOERROR)
	{
		I_Error("I_PauseSong could not pause the MIDI stream! (Error code 0x%08x)", mmr);
	}
*/

//  MUS_PauseSong(handle);
}

void I_ResumeSong(int handle)
{
	HMIDISTRM hms = (HMIDISTRM)handle;
	MMRESULT mmr;

	if(!g_fPlayMusic || !g_hMidiStrm || !handle)
		return;

	mmr = midiStreamRestart(g_hMidiStrm);

/*
	if((mmr = midiStreamRestart(g_hMidiStrm)) != MMSYSERR_NOERROR)
	{
		I_Error("I_PlaySong could not restart the MIDI stream! (Error code 0x%08x)", mmr);
	}
*/
//  MUS_ResumeSong(handle);
}

void I_SetMusicVolume(int volume)
{
	MMRESULT mmr;
	DWORD dwVolume;

	if(!g_fPlayMusic || !g_hMidiStrm)
		return;

	// Map range of 0 - 15 to 0 - 0xFFFF
	volume *= 4369;
	dwVolume = volume | (((unsigned)volume) << 16);

	// Note: we can't check for an error code because on some cards this won't work...
	//
	midiOutSetVolume((HMIDIOUT)g_hMidiStrm, dwVolume);

//  MUS_SetMasterVolume(volume*8);
//  snd_MusicVolume = volume;
}

/*
 *
 *                              SONG API
 *
 */

int I_RegisterSong(void *data, int lumpNum)
{
	MMRESULT hr;
	DWORD dwUsedDWORDs;
	unsigned i;
	UINT nMIDIDeviceID;
	MIDIPROPTIMEDIV mptd;
	MIDIPROPTEMPO mpt;

	if(!g_fPlayMusic || !data)
		return 0;

	nMIDIDeviceID = MIDI_MAPPER;

	if((hr = midiStreamOpen(&g_hMidiStrm, 
							&nMIDIDeviceID, 
							1, 
							(DWORD)g_hWnd, 
							(DWORD)&g_MidiState, 
							CALLBACK_WINDOW)) != MMSYSERR_NOERROR)
	{
		g_fPlayMusic = false;
		return 0;
	}

	g_fPlayMusic = true;

	ZeroMemory(&g_M2M, sizeof(MUS2MIDIState));
	ZeroMemory(&g_MidiState, sizeof(MIDIState));

	mptd.cbStruct = sizeof(MIDIPROPTIMEDIV);
	mptd.dwTimeDiv = 95;

	if((hr = midiStreamProperty(g_hMidiStrm, (BYTE *)&mptd, MIDIPROP_SET | MIDIPROP_TIMEDIV)) != MMSYSERR_NOERROR)
	{
		I_Error("Could not set TimeDiv property! (Error code 0x%08x)", hr);
	}

	mpt.cbStruct = sizeof(MIDIPROPTEMPO);
	mpt.dwTempo = 631578;
	if((hr = midiStreamProperty(g_hMidiStrm, (BYTE *)&mpt, MIDIPROP_SET | MIDIPROP_TEMPO)) != MMSYSERR_NOERROR)
	{
		I_Error("Could not set TimeDiv property! (Error code 0x%08x)", hr);
	}

	midiOutSetVolume((HMIDIOUT)g_hMidiStrm, ((unsigned)(snd_MusicVolume * 4369) << 16) | (snd_MusicVolume * 4369));

	// Make sure we cleaned-up from last time...
	//
	assert(g_M2M.m_rgmidEvents == NULL			&& 
		   g_M2M.m_mf.m_rgbMusicData == NULL	&& 
		   g_MidiState.m_rgpBuffer == NULL		&& 
		   g_MidiState.m_rgMidiHdr == NULL		&& 
		   g_MidiState.m_rgdwcBufferLength == NULL);

	memcpy(&g_M2M.m_mf, data, 16);
	g_M2M.m_mf.m_rgwPatches = NULL;
	g_M2M.m_mf.m_rgbMusicData = (byte *)malloc(g_M2M.m_mf.m_wcbMusicData);
	memcpy(g_M2M.m_mf.m_rgbMusicData, ((byte *)data) + g_M2M.m_mf.m_wcbHeaderData, g_M2M.m_mf.m_wcbMusicData);

	g_M2M.m_dwcBufferDWORDs = ((g_M2M.m_mf.m_wcbMusicData / 2) * 3) + 20;

	g_M2M.m_rgmidEvents = (DWORD *)GlobalAllocPtr(GHND, g_M2M.m_dwcBufferDWORDs * sizeof(DWORD));
	g_M2M.m_pCurMIDEvent = g_M2M.m_rgmidEvents;
	g_M2M.m_pCurMUSEvent = g_M2M.m_mf.m_rgbMusicData;
	g_M2M.m_lNextWaitTime = 0;

	ConvertMUSEventsToMIDIEvents(&g_M2M);

	dwUsedDWORDs = g_M2M.m_pCurMIDEvent - g_M2M.m_rgmidEvents;
	g_MidiState.m_dwcBuffers = (dwUsedDWORDs / 16383) + 1;
	g_MidiState.m_rgpBuffer = (DWORD **)malloc(g_MidiState.m_dwcBuffers * sizeof(DWORD *));
	g_MidiState.m_rgdwcBufferLength = (DWORD *)malloc(g_MidiState.m_dwcBuffers * sizeof(DWORD));
	g_MidiState.m_rgMidiHdr = (MIDIHDR *)malloc(g_MidiState.m_dwcBuffers * sizeof(MIDIHDR));

	ZeroMemory(g_MidiState.m_rgMidiHdr, g_MidiState.m_dwcBuffers * sizeof(MIDIHDR));

	for(i = 0; i < g_MidiState.m_dwcBuffers; i++)
	{
		g_MidiState.m_rgpBuffer[i] = g_M2M.m_rgmidEvents + (i * 16383);

		// This length is measured in DWORDs...
		//
		g_MidiState.m_rgdwcBufferLength[i] = dwUsedDWORDs > 16383 ? 16383 : dwUsedDWORDs;

		// These lengths are measured in BYTEs...
		//
		g_MidiState.m_rgMidiHdr[i].dwBufferLength = g_MidiState.m_rgdwcBufferLength[i] * sizeof(DWORD);
		g_MidiState.m_rgMidiHdr[i].dwBytesRecorded = g_MidiState.m_rgdwcBufferLength[i] * sizeof(DWORD);
		g_MidiState.m_rgMidiHdr[i].dwFlags = 0;
		g_MidiState.m_rgMidiHdr[i].lpData = (char *)g_MidiState.m_rgpBuffer[i];

		if((hr = midiOutPrepareHeader((HMIDIOUT)g_hMidiStrm, &g_MidiState.m_rgMidiHdr[i], sizeof(MIDIHDR))) != MMSYSERR_NOERROR)
		{
			I_Error("Could not prepare MIDI header! (Error code 0x%08x)", hr);
		}

		dwUsedDWORDs -= g_MidiState.m_rgdwcBufferLength[i];
	}

	g_MidiState.m_dwiCurrentBuffer = 0;
	g_MidiState.m_fDontPlay = FALSE;

	if((hr = midiStreamRestart(g_hMidiStrm)) != MMSYSERR_NOERROR)
	{
		I_Error("Could not restart stream! (Error code 0x%08x)", hr);
	}

	return (int)g_hMidiStrm;

/*
  int rc = MUS_RegisterSong(data);
#ifdef SNDDEBUG
  if (rc<0) ST_Message("    MUS_Reg() returned %d\n", rc);
#endif
  return rc;
*/
}

void I_UnRegisterSong(int handle)
{
	unsigned i;
	MMRESULT hr;

	if(!g_fPlayMusic || !g_hMidiStrm || !handle)
		return;

	for(i = 0; i < g_MidiState.m_dwcBuffers; i++)
	{
		hr = midiOutUnprepareHeader((HMIDIOUT)g_hMidiStrm, &g_MidiState.m_rgMidiHdr[i], sizeof(MIDIHDR));
/*
		if((hr = midiOutUnprepareHeader((HMIDIOUT)g_hMidiStrm, &g_MidiState.m_rgMidiHdr[i], sizeof(MIDIHDR))) != MMSYSERR_NOERROR)
		{
			char szBuffer[MAXERRORLENGTH];
			midiOutGetErrorText(hr, szBuffer, MAXERRORLENGTH);
			I_Error("I_UnRegisterSong: %s (Error code 0x%08x)", szBuffer, hr);
		}
*/
	}

	midiStreamClose(g_hMidiStrm);
	g_hMidiStrm = NULL;

	assert(g_MidiState.m_fDontPlay == TRUE);

	free(g_M2M.m_mf.m_rgbMusicData);
	g_M2M.m_mf.m_rgbMusicData = NULL;
	GlobalFreePtr(g_M2M.m_rgmidEvents);
	g_M2M.m_rgmidEvents = NULL;

	free(g_MidiState.m_rgdwcBufferLength);
	g_MidiState.m_rgdwcBufferLength = NULL;
	free(g_MidiState.m_rgMidiHdr);
	g_MidiState.m_rgMidiHdr = NULL;
	free(g_MidiState.m_rgpBuffer);
	g_MidiState.m_rgpBuffer = NULL;

/*
	int rc = MUS_UnregisterSong(handle);
#ifdef SNDDEBUG
  if (rc < 0) ST_Message("    MUS_Unreg() returned %d\n", rc);
#endif
*/
}

#if 0
int I_QrySongPlaying(int handle)
{
	// SND_TODO:
/*
	int rc = MUS_QrySongPlaying(handle);
#ifdef SNDDEBUG
  if (rc < 0) ST_Message("    MUS_QrySP() returned %d\n", rc);
#endif
  return rc;
*/
	return 0;
}
#endif	// 0


// Stops a song.  MUST be called before I_UnregisterSong().

void I_StopSong(int handle)
{
	MMRESULT mmr;
	HMIDISTRM hms = (HMIDISTRM)handle;

	if(!g_fPlayMusic || !g_hMidiStrm || !handle)
		return;

	g_MidiState.m_fDontPlay = TRUE;

	mmr = midiStreamStop(g_hMidiStrm);

//	if((mmr = midiStreamStop(g_hMidiStrm)) != MMSYSERR_NOERROR)
//	{
//		I_Error("I_StopSong could not stop MIDI stream! (Error code 0x%08x)", mmr);
//	}

/*
	int rc;
  rc = MUS_StopSong(handle);
#ifdef SNDDEBUG
  if (rc < 0) ST_Message("    MUS_StopSong() returned %d\n", rc);
#endif
*/
}

void I_PlaySong(int handle, boolean looping)
{
	MMRESULT mmr;
	MMTIME mmt;

	if(!g_fPlayMusic || !g_hMidiStrm || !handle)
		return;

	mmt.wType = TIME_BYTES;
	mmt.u.cb = 0;

	midiStreamPosition((HMIDIOUT)g_hMidiStrm, &mmt, sizeof(MMTIME));

	g_MidiState.m_fDontPlay = FALSE;
	g_MidiState.m_fLooping = looping;
	g_MidiState.m_dwiCurrentBuffer = 0;

	mmr = midiStreamRestart(g_hMidiStrm);
	mmr = midiStreamOut(g_hMidiStrm, &g_MidiState.m_rgMidiHdr[0], sizeof(MIDIHDR));

/*
	if((mmr = midiStreamRestart(g_hMidiStrm)) != MMSYSERR_NOERROR)
	{
		I_Error("I_PlaySong could not restart the MIDI stream! (Error code 0x%08x)", mmr);
	}
	if((mmr = midiStreamOut(g_hMidiStrm, &g_MidiState.m_rgMidiHdr[0], sizeof(MIDIHDR))) != MMSYSERR_NOERROR)
	{
		I_Error("I_PlaySong could not start MIDI stream playback! (Error code 0x%08x)", mmr);
	}
*/
/*
	int rc;
  rc = MUS_ChainSong(handle, looping ? handle : -1);
#ifdef SNDDEBUG
  if (rc < 0) ST_Message("    MUS_ChainSong() returned %d\n", rc);
#endif
  rc = MUS_PlaySong(handle, snd_MusicVolume);
#ifdef SNDDEBUG
  if (rc < 0) ST_Message("    MUS_PlaySong() returned %d\n", rc);
#endif
*/
}

#endif	// 0

/*
 *
 *                                 SOUND FX API
 *
 */

// Gets lump nums of the named sound.  Returns pointer which will be
// passed to I_StartSound() when you want to start an SFX.  Must be
// sure to pass this to UngetSoundEffect() so that they can be
// freed!


int I_GetSfxLumpNum(sfxinfo_t *sound)
{
  return W_GetNumForName(sound->lumpname);

}

void I_SetSfxVolume(int volume)
{
  snd_MaxVolume = volume; // THROW AWAY?
}


HRESULT I_LockAndLoadDSB(int id, int index)
{
	void *pvSnd;
	DWORD dwSnd;
	HRESULT hr;
	DWORD *pdwcbLength;

	pdwcbLength = (DWORD *)S_sfx[id].snd_ptr + 1;

	// Now immediately lock the buffer and copy the sound data to it...
	//
	if(FAILED(hr = IDirectSoundBuffer_Lock(S_sfx[id].rgpDSB[index], 0, 0,
										   &pvSnd, &dwSnd, NULL, NULL,
										   DSBLOCK_ENTIREBUFFER)))
	{
		ST_Message("Failed to Lock DS Buffer!\n");
		IDirectSoundBuffer_Release(S_sfx[id].rgpDSB[index]);
		S_sfx[id].rgpDSB[index] = NULL;
		return hr;
	}

	CopyMemory(pvSnd, (BYTE *)S_sfx[id].snd_ptr + 8, *pdwcbLength);

	if(FAILED(hr = IDirectSoundBuffer_Unlock(S_sfx[id].rgpDSB[index], pvSnd, dwSnd, NULL, 0)))
	{
		ST_Message("Failed to Unlock DS Buffer!\n");
		IDirectSoundBuffer_Release(S_sfx[id].rgpDSB[index]);
		S_sfx[id].rgpDSB[index] = NULL;
		return hr;
	}

	return S_OK;
}


HRESULT I_BuildDSB(int id, int index)
{
	WAVEFORMATEX wfx;
	DSBUFFERDESC dsbdesc;
	DWORD *pdwcbLength;
	HRESULT hr;

	_ASSERTE(S_sfx[id].snd_ptr != NULL);

	pdwcbLength = (DWORD *)S_sfx[id].snd_ptr + 1;

#ifdef _DEBUG
	if( (*pdwcbLength + 8 != lumpinfo[S_sfx[id].lumpnum].size)	||
		(*((DWORD *)S_sfx[id].snd_ptr) != 0x2B110003) )
	{
		I_Error("Discrepency found in sound info! (id = %d)", id);
	}
#endif

	ZeroMemory(S_sfx[id].rgpDSB, MAX_SOUND_COPIES * sizeof(IDirectSoundBuffer *));
	ZeroMemory(&wfx, sizeof(WAVEFORMATEX));
	wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nChannels = 1;
	wfx.wBitsPerSample = 8;     
	wfx.nSamplesPerSec = SND_SAMPLERATE;
	wfx.nBlockAlign = (wfx.nChannels * wfx.wBitsPerSample) / 8;
	wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign; 
//	wfx.cbSize = 0;

	// Set up DSBUFFERDESC structure. 
	//
    ZeroMemory(&dsbdesc, sizeof(DSBUFFERDESC));
    dsbdesc.dwSize = sizeof(DSBUFFERDESC); 

	// Need default controls (pan, volume, frequency). 
	//
	dsbdesc.dwFlags = DSBCAPS_CTRLFREQUENCY | DSBCAPS_CTRLPAN | DSBCAPS_CTRLVOLUME | DSBCAPS_STATIC;
	if(snd_SfxDevice == snd_DS3D)
	{
		// Add the 3D parameters...
		//
		dsbdesc.dwFlags |= DSBCAPS_CTRL3D | DSBCAPS_MUTE3DATMAXDISTANCE;
	}

	dsbdesc.dwBufferBytes = *pdwcbLength;
	dsbdesc.lpwfxFormat = &wfx;

	if(FAILED(hr = IDirectSound_CreateSoundBuffer(g_pDS, &dsbdesc, &S_sfx[id].rgpDSB[index], NULL)))
	{
		ST_Message("Failed to CreateSoundBuffer! (dwSoundSize = %d\n", *pdwcbLength);
		return hr;
	}

	return S_OK;
}


HRESULT I_CreateDSBuffer(int id)
{
	HRESULT hr;
#ifdef _DEBUG
	DSCAPS	dscaps;
#endif

	if(snd_SfxDevice == snd_none)
	{
		return S_OK;
	}

	// Now allocate an array of 8 IDirectSoundBuffer pointers.
	// We'll make up to 8 copies of the sound buffer (as needed)
	// in order to play the same sound simlutaneously.
	//
	S_sfx[id].rgpDSB = (IDirectSoundBuffer **)malloc(MAX_SOUND_COPIES * sizeof(IDirectSoundBuffer *));
	if(!S_sfx[id].rgpDSB)
	{
		I_Error("Out of memory trying to allocate space for IDirectSoundBuffer pointers!");
	}

	if(FAILED(hr = I_BuildDSB(id, 0)))
	{
		return hr;
	}

	if(FAILED(hr = I_LockAndLoadDSB(id, 0)))
	{
		return hr;
	}

#ifdef _DEBUG
	ZeroMemory(&dscaps, sizeof(DSCAPS));
	dscaps.dwSize = sizeof(DSCAPS);
	hr = IDirectSound_GetCaps(g_pDS, &dscaps);
#endif

	// Ok, we're ready to rock-n-roll with this sound buffer!
	// (i.e. we're ready to play it...)
	//
	return S_OK;
}


void I_DestroyDSBuffer(int id)
{
	int i;

	if(snd_SfxDevice == snd_none || S_sfx[id].rgpDSB == NULL)
	{
		return;
	}

	for(i = MAX_SOUND_COPIES - 1; i >= 0; i--)
	{
		if(S_sfx[id].rgpDSB[i])
		{
			IDirectSoundBuffer_Release(S_sfx[id].rgpDSB[i]);
		}
	}

	free(S_sfx[id].rgpDSB);
	S_sfx[id].rgpDSB = NULL;
}


void I_UpdateListenerInfoAndCommit(mobj_t *listener)
{
	HRESULT hr;
	float x, y, z;
	double radAngle;
	double fpSin, fpCos;

	if(snd_SfxDevice != snd_DS3D)
	{
		return;
	}

	if(!listener || !g_pDS3DL)
	{
		return;
	}

	x = (double)listener->x / 65536.0;
	y = (double)listener->z / 65536.0;
	z = (double)listener->y / 65536.0;

	if(FAILED(hr = IDirectSound3DListener_SetPosition(g_pDS3DL, x, y, z, DS3D_DEFERRED)))
	{
		I_Error("Could not set Listener's position! (Error code 0x%08x)", hr);
	}

	x = (double)listener->momx / 65536.0;
	y = (double)listener->momz / 65536.0;
	z = (double)listener->momy / 65536.0;

	if(FAILED(hr = IDirectSound3DListener_SetVelocity(g_pDS3DL, x, y, z, DS3D_DEFERRED)))
	{
		I_Error("Could not set Listener's velocity! (Error code 0x%08x)", hr);
	}

//		radAngle = (double)listener->angle / HEXENANGLES_TO_RADIANS;
	radAngle = (double)((unsigned)viewangle) / HEXENANGLES_TO_RADIANS;

	__asm
	{
		wait
		fld		radAngle
		fsincos
		fstp	fpCos
		fstp	fpSin
	}

	x = fpCos;
	z = fpSin;

	if(FAILED(hr = IDirectSound3DListener_SetOrientation(g_pDS3DL, x, 0.0f, z, 0.0f, 1.0f, 0.0f, DS3D_DEFERRED)))
	{
		I_Error("Could not set Listener's orientation! (Error code 0x%08x)", hr);
	}

	if(FAILED(hr = IDirectSound3DListener_CommitDeferredSettings(g_pDS3DL)))
	{
		I_Error("Could not commit DirectSound3D settings! (Error code 0x%08x)", hr);
	}
}


int I_HexenVolumeToDSVolume(int vol)
{
	int dsVol;
	float fpRads;

	// Assume 'vol' has been set to a range from 0 to 127, where 0 is silence...
	//
#ifdef _DEBUG
	if(vol > 127)
	{
		I_Error("Bad volume found in I_SetSoundSettings!");
	}
#endif

	// First let's adjust for the volume setting from the menus...
	//
	dsVol = 1905 - (snd_MaxVolume * vol);

	dsVol *= -1;

/*
	// Now dsVol is in range 0 - 1905, where 0 is full sound and 1905 is
	// basically silence. Now map this range to 0 - PI/2.
	//
	fpRads = (float)dsVol / 1212.760666f;

	// Now use cosine to get a percentage of the volume we 
	// should apply...
	//

	__asm
	{
		fld		fpRads
		fcos
		fstp	fpRads
	}

	// Now fpRads holds a percentage of the total sound volume we want, 
	// as a number from 1 (all sound) to 0 (silence.)
	// Invert that...
	//
	fpRads = 1.0f - fpRads;

	// Ok, now 0 is all sound and 1 is silence.
	//
	// We're finally ready to convert this to a
	// DirectSound volume...
	//

	dsVol = fpRads * -10000.0f;
*/

	return dsVol;
}


void I_SetSoundSettings(channel_t *channel, boolean fOriginIsPlayer)
{
	HRESULT hr;
	int vol;
	float x, y, z;
	float vx, vy, vz;
	IDirectSoundBuffer *pDSB = NULL;
	IDirectSound3DBuffer *pDS3D = NULL;
	DWORD dwCurMode;
	int id, index;

	index = (channel->handle >> 16) & 0xFFFF;
	id = (channel->handle & 0xFFFF) - 1;

	if(S_sfx[id].rgpDSB == NULL || S_sfx[id].rgpDSB[index] == NULL)
	{
		return;
	}

	pDSB = S_sfx[id].rgpDSB[index];

	if(snd_SfxDevice == snd_DS3D)
	{
		// channel->volume comes in as a range from 0 (silent) to 127 (full volume.)
		//
		// DirectSound takes a range from 0 (full volume) to -10,000 (silent.)
		//
		// (snd_MaxVolume is a range from 0 to 15...)
		//
		vol = I_HexenVolumeToDSVolume(channel->volume);

		if(FAILED(hr = IDirectSoundBuffer_SetVolume(pDSB, vol)))
		{
			I_Error("Could not set volume level for sound id %d! (Error code 0x%08x)", id, hr);
		}

		if(FAILED(hr = IDirectSoundBuffer_SetFrequency(pDSB, channel->pitch)))
		{
			I_Error("Could not set frequency rate for sound id %d! (Error code 0x%08x)", id, hr);
		}

		if(FAILED(hr = IDirectSoundBuffer_QueryInterface(pDSB, &IID_IDirectSound3DBuffer, (void **)&pDS3D)))
		{
			I_Error("Could not retrieve IDirectSound3DBuffer from IDirectSoundBuffer! (Error code 0x%08x)", hr);
		}

		if(FAILED(hr = IDirectSound3DBuffer_GetMode(pDS3D, &dwCurMode)))
		{
			I_Error("Could not retrieve Mode from IDirectSound3D! (Error code 0x%08x)", hr);
		}

		if(fOriginIsPlayer)
		{
			x = 0.0f;
			y = 0.0f;
			z = 0.0f;

			vx = 0.0f;
			vy = 0.0f;
			vz = 0.0f;

			if(dwCurMode != DS3DMODE_HEADRELATIVE)
			{
				if(FAILED(hr = IDirectSound3DBuffer_SetMode(pDS3D, DS3DMODE_HEADRELATIVE, DS3D_IMMEDIATE)))
				{
					I_Error("Could not set sound's mode to DS3DMODE_HEADRELATIVE! (Error code 0x%08x)", hr);
				}
			}
		}
		else
		{
			x = (double)channel->mo->x / 65536.0;
			y = (double)channel->mo->z / 65536.0;
			z = (double)channel->mo->y / 65536.0;

			vx = (double)channel->mo->momx / 65536.0;
			vy = (double)channel->mo->momz / 65536.0;
			vz = (double)channel->mo->momy / 65536.0;

			if(dwCurMode != DS3DMODE_NORMAL)
			{
				if(FAILED(hr = IDirectSound3DBuffer_SetMode(pDS3D, DS3DMODE_NORMAL, DS3D_IMMEDIATE)))
				{
					I_Error("Could not set sound's mode to DS3DMODE_HEADRELATIVE! (Error code 0x%08x)", hr);
				}
			}
		}

		if(FAILED(hr = IDirectSound3DBuffer_SetPosition(pDS3D, x, y, z, DS3D_IMMEDIATE)))
		{
			I_Error("Could not set sound's position! (Error code 0x%08x)", hr);
		}

		if(FAILED(hr = IDirectSound3DBuffer_SetVelocity(pDS3D, vx, vy, vz, DS3D_IMMEDIATE)))
		{
			I_Error("Could not set sound's velocity! (Error code 0x%08x)", hr);
		}

		IDirectSound3DBuffer_Release(pDS3D);
	}
	else
	{
		int sep;

		// Regular DirectSound...calculate some psuedo-3D stuff so the sound is at least decent...
		//
		if(fOriginIsPlayer == false)
		{
			int absx, absy;
			int dist;
			int angle;
			float rads;

			absx = abs(channel->mo->x - players[displayplayer].mo->x);
			absy = abs(channel->mo->y - players[displayplayer].mo->y);
			dist = absx+absy-(absx > absy ? absy>>1 : absx>>1);
			dist >>= FRACBITS;

#ifdef _DEBUG
			if(dist >= MAX_SND_DIST)
			{
				I_Error("Invalid 'dist' value in I_SetSoundSettings!");
			}
#endif
			if(dist < 0)
			{
				dist = 0;
			}

			vol = ((SoundCurve[dist] * channel->volume) >> 7) + 1;

			angle = R_PointToAngle2(players[displayplayer].mo->x,
								    players[displayplayer].mo->y, 
								    channel->mo->x, 
								    channel->mo->y);

			// Normalize the angle so that it is relative to the direction I'm viewing,
			// then convert it to radians...
			//
			rads = (double)((unsigned)(angle - viewangle)) / HEXENANGLES_TO_RADIANS;

			__asm
			{
				wait
				fld		rads
				fsin
				fstp	rads
			}

			sep = (int)(rads * -10000.0f);
		}
		else
		{
			vol = channel->volume;
			sep = 0;
		}

		vol = I_HexenVolumeToDSVolume(vol);

		if(FAILED(hr = IDirectSoundBuffer_SetVolume(pDSB, vol)))
		{
			I_Error("Could not set volume level for sound id %d! (Error code 0x%08x)", id, hr);
		}

		if(FAILED(hr = IDirectSoundBuffer_SetPan(pDSB, sep)))
		{
			I_Error("Could not set pan level for sound id %d! (Error code 0x%08x)", id, hr);
		}

		if(FAILED(hr = IDirectSoundBuffer_SetFrequency(pDSB, channel->pitch)))
		{
			I_Error("Could not set frequency rate for sound id %d! (Error code 0x%08x)", id, hr);
		}
	}
}


// Note that I_UpdateSoundInfo() won't be called on sounds whose mobj is the player!
//
void I_UpdateSoundInfo(channel_t *channel)
{
	if(snd_SfxDevice == snd_none)
	{
		return;
	}

	if(channel->handle == 0 || channel->mo == NULL)
	{
		return;
	}

	I_SetSoundSettings(channel, false);
}


void I_StartSound(int id, channel_t *channel, boolean fOriginIsPlayer)
{
	HRESULT hr;
	int iCopyToPlay;
	int iNextAvailableSlot;
	int i;
	DWORD dwStatus;

	if(snd_SfxDevice == snd_none)
	{
		return;
	}

	iCopyToPlay = -1;
	iNextAvailableSlot = -1;

	for(i = 0; i < MAX_SOUND_COPIES; i++)
	{
		if(S_sfx[id].rgpDSB[i])
		{
			if(FAILED(hr = IDirectSoundBuffer_GetStatus(S_sfx[id].rgpDSB[i], &dwStatus)))
			{
				I_Error("Could not retrieve status of DirectSoundBuffer! (Error code 0x%08x)", hr);
			}
			if(!(dwStatus & DSBSTATUS_PLAYING))
			{
				// This sound isn't currently playing, so we can use it!
				//
				if(FAILED(hr = IDirectSoundBuffer_SetCurrentPosition(S_sfx[id].rgpDSB[i], 0)))
				{
					I_Error("Could not reset the play position of a DirectSoundBuffer! (Error code 0x%08x)", hr);
				}
				iCopyToPlay = i;
				break;
			}
		}
		else
		{
			// We're not using this index yet (i.e. we could create a sound
			// buffer copy in this slot...)
			//
			if(iNextAvailableSlot == -1)
			{
				iNextAvailableSlot = i;
			}
		}
	}

	if(iCopyToPlay == -1)
	{
		if(iNextAvailableSlot == -1)
		{
			// All of our sound copies are already busy playing,
			// so do nothing.
			// We need to return a Handle to the caller that identifies
			// this particular sound instance. The handle is constructed
			// as a combination of the id (plus one) and the index into
			// our available slots. The id (plus one) is stored in the 
			// lower 16 bits and the index in the upper 16. But for this
			// special case, we'll store 0xFFFF in the upper 16 bits
			// (since we really didn't start playing a sound at all...)
			//
			channel->handle = 0xFFFF0000 | (id + 1);
			return;
		}
		else
		{
			// Ok, we have an empty slot that we can use...
			// But first, we need to duplicate the DS buffer.
			//
			if(FAILED(hr = IDirectSound_DuplicateSoundBuffer(g_pDS, S_sfx[id].rgpDSB[iNextAvailableSlot - 1], &S_sfx[id].rgpDSB[iNextAvailableSlot])))
			{
				// Hmmm, we couldn't duplicate the buffer, but that could mean that the existing buffer
				// lives in hardware and is being hardware-mixed, but we are out of additional mixers/memory
				// to let the new sound also be hardware mixed. So let's just try to create a new buffer
				// (without using "DuplicateSoundBuffer" and let DirectSound place the new buffer in software
				// if necessary.
				//
				if(FAILED(hr = I_BuildDSB(id, iNextAvailableSlot)))
				{
					I_Error("Could neither DuplicateSoundBuffer nor CreateSoundBuffer! (Error code 0x%08x)", hr);
				}
				if(FAILED(hr = I_LockAndLoadDSB(id, iNextAvailableSlot)))
				{
					I_Error("Could not copy sound into non-DuplicateSoundBuffer sound buffer! (Error code 0x%08x)", hr);
				}
			}
			iCopyToPlay = iNextAvailableSlot;
		}
	}

	channel->handle = (iCopyToPlay << 16) | (id + 1);

	if(channel->mo)
	{
		I_SetSoundSettings(channel, fOriginIsPlayer);
	}
	else
	{
		// Without a mobj, the only thing we can set is the volume...
		//
		int vol = I_HexenVolumeToDSVolume(channel->volume);

		if(FAILED(hr = IDirectSoundBuffer_SetVolume(S_sfx[id].rgpDSB[iCopyToPlay], vol)))
		{
			I_Error("Could not set volume level for sound id %d! (Error code 0x%08x)", id, hr);
		}
	}

	hr = IDirectSoundBuffer_Play(S_sfx[id].rgpDSB[iCopyToPlay], 0, 0, 0);

	if(hr == DSERR_BUFFERLOST)
	{
		if(SUCCEEDED(hr = IDirectSoundBuffer_Restore(S_sfx[id].rgpDSB[iCopyToPlay])))
		{
			if(SUCCEEDED(hr = I_LockAndLoadDSB(id, iCopyToPlay)))
			{
				hr = IDirectSoundBuffer_Play(S_sfx[id].rgpDSB[iCopyToPlay], 0, 0, 0);
			}
		}
	}

	if(FAILED(hr))
	{
		I_Error("Could not play sound! (Error code 0x%08x)", hr);
	}

//	return SFX_PlayPatch(data, pitch, sep, vol, 0, 0);
}


void I_StopSound(int handle)
{
	if(snd_SfxDevice == snd_none)
	{
		return;
	}

	if(handle)
	{
		int id = (handle & 0xFFFF) - 1;
		int index = (handle >> 16) & 0xFFFF;

		if(index != 0xFFFF)
		{
			if(S_sfx[id].rgpDSB && S_sfx[id].rgpDSB[index])
			{
				IDirectSoundBuffer_Stop(S_sfx[id].rgpDSB[index]);
			}
		}
	}
//  SFX_StopPatch(handle);
}


int I_SoundIsPlaying(int handle)
{
	DWORD dwStatus;

	if(snd_SfxDevice == snd_none)
	{
		return 0;
	}

	if(handle)
	{
		int id = (handle & 0xFFFF) - 1;
		int index = (handle >> 16) & 0xFFFF;

		if(index != 0xFFFF)
		{
			if(S_sfx[id].rgpDSB && S_sfx[id].rgpDSB[index])
			{
				IDirectSoundBuffer_GetStatus(S_sfx[id].rgpDSB[index], &dwStatus);
				return dwStatus & DSBSTATUS_PLAYING;
			}
		}
	}

	return 0;
//  return SFX_Playing(handle);
}


void I_UpdateSoundParams(int handle, int vol, int sep, int pitch)
{
	// SND_TODO:
//  SFX_SetOrigin(handle, pitch, sep, vol);
}

/*
 *
 *                                                      SOUND STARTUP STUFF
 *
 *
 */


// inits all sound stuff

void I_StartupSound (void)
{
//	int rc, i;
	HRESULT hr;
	DSCAPS dscaps;
	DSBUFFERDESC dsbd;
	IDirectSoundBuffer *pDSBPrimary;
	WAVEFORMATEX wfx;
	char errorBuf[128];

	if(debugmode)
		ST_Message("I_StartupSound: Hope you hear a pop.\n");

	// Let's start off optimistic...
	//
	if(!nods3d)
	{
		snd_SfxDevice = snd_DS3D;
	}
	else
	{
		snd_SfxDevice = snd_DS;
	}

	if(FAILED(hr = DirectSoundCreate(NULL, &g_pDS, NULL)))
	{
		sprintf(errorBuf, "Could not create DirectSound object! (Error code 0x%08x)", hr);

		if(forcesound)
		{
			I_Error(errorBuf);
		}
		else
		{
			ST_Message(errorBuf);
			snd_SfxDevice = snd_none;
			return;
		}
	}

	if(FAILED(hr = IDirectSound_SetCooperativeLevel(g_pDS, g_hWnd, DSSCL_PRIORITY)))
	{
		sprintf(errorBuf, "Could set DirectSound cooperative level! (Error code 0x%08x)", hr);

		if(forcesound)
		{
			I_Error(errorBuf);
		}
		else
		{
			ST_Message(errorBuf);
			snd_SfxDevice = snd_none;
			IDirectSound_Release(g_pDS);
			g_pDS = NULL;
			return;
		}
	}

	ZeroMemory(&dscaps, sizeof(DSCAPS));
	dscaps.dwSize = sizeof(DSCAPS);
	if(FAILED(hr = IDirectSound_GetCaps(g_pDS, &dscaps)))
	{
		sprintf(errorBuf, "Could get DirectSound capabilities! (Error code 0x%08x)", hr);

		if(forcesound)
		{
			I_Error(errorBuf);
		}
		else
		{
			ST_Message(errorBuf);
			snd_SfxDevice = snd_none;
			IDirectSound_Release(g_pDS);
			g_pDS = NULL;
			return;
		}
	}

	if(snd_SfxDevice == snd_DS3D)
	{
		// Now, test for support for what we'll need to do DirectSound3D...
		//
		if(!(dscaps.dwFlags & DSCAPS_PRIMARYSTEREO))
		{
			sprintf(errorBuf, "Warning: your sound card does not support enough features to enable 3D sound.");

			if(forcesound)
			{
				I_Error(errorBuf);
			}
			else
			{
				ST_Message(errorBuf);
				snd_SfxDevice = snd_DS;
			}
		}
	}

/*
	if((dscaps.dwMaxHwMixingAllBuffers != 0)	&&
	   (dscaps.dwFreeHwMixingAllBuffers != dscaps.dwMaxHwMixingAllBuffers))
	{
		SetWindowPos(g_hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOCOPYBITS | SWP_NOMOVE | SWP_NOSIZE | SWP_NOREDRAW);
		if(MessageBox(NULL, 
					  "Another application is currently using some of your sound card's resources.\nThis will cause DXHexen to use software mixing much more frequently, and your performance will suffer accordingly.\nPress Cancel to abort DXHexen so you can close the other application, or press OK to continue.", 
					  "Warning!", 
					  MB_OKCANCEL | MB_ICONWARNING) != IDOK)
		{
			I_Error("");
		}
		SetWindowPos(g_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOCOPYBITS | SWP_NOMOVE | SWP_NOSIZE);
	}
*/

	if(snd_SfxDevice == snd_DS3D)
	{
		ZeroMemory(&dsbd, sizeof(DSBUFFERDESC));
		dsbd.dwSize = sizeof(DSBUFFERDESC);
		dsbd.dwFlags = DSBCAPS_CTRL3D | DSBCAPS_PRIMARYBUFFER;

		if(FAILED(hr = IDirectSound_CreateSoundBuffer(g_pDS, &dsbd, &pDSBPrimary, NULL)))
		{
			sprintf(errorBuf, "Could not create DirectSound primary buffer! (Error code 0x%08x)", hr);

			if(forcesound)
			{
				I_Error(errorBuf);
			}
			else
			{
				snd_SfxDevice = snd_DS;
				ST_Message(errorBuf);
			}
		}
	}

	if(snd_SfxDevice == snd_DS3D)
	{
		// For the output buffer, make it stereo and 22KHz (the sounds themselves
		// are mono and 11KHz.) 
		// This means you'll need an SBPro or better sound-card to run...
		//
		ZeroMemory(&wfx, sizeof(WAVEFORMATEX));
		wfx.wFormatTag = WAVE_FORMAT_PCM;
		wfx.nChannels = 2;
		wfx.wBitsPerSample = 8;
		wfx.nSamplesPerSec = SND_SAMPLERATE * 2;
		wfx.nBlockAlign = (wfx.nChannels * wfx.wBitsPerSample) / 8;
		wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;

		if(FAILED(hr = IDirectSoundBuffer_SetFormat(pDSBPrimary, &wfx)))
		{
			sprintf(errorBuf, "Could not set format of primary buffer! (Error code 0x%08x)", hr);

			if(forcesound)
			{
				I_Error(errorBuf);
			}
			else
			{
				snd_SfxDevice = snd_DS;
				ST_Message(errorBuf);
				IDirectSoundBuffer_Release(pDSBPrimary);
			}
		}
	}

	if(snd_SfxDevice == snd_DS3D)
	{
		if(FAILED(hr = IDirectSoundBuffer_QueryInterface(pDSBPrimary, &IID_IDirectSound3DListener, (void **)&g_pDS3DL)))
		{
			sprintf(errorBuf, "Could not create IDirectSound3DListener object! (Error code 0x%08x)", hr);

			if(forcesound)
			{
				I_Error(errorBuf);
			}
			else
			{
				snd_SfxDevice = snd_DS;
				ST_Message(errorBuf);
				IDirectSoundBuffer_Release(pDSBPrimary);
			}
		}
	}

	if(snd_SfxDevice == snd_DS3D)
	{
		// Now we have a reference with our g_pDS3DL object. We can release this one...
		//
		IDirectSoundBuffer_Release(pDSBPrimary);

		if(FAILED(hr = IDirectSound3DListener_SetDistanceFactor(g_pDS3DL, 0.005f, DS3D_IMMEDIATE)))
		{
			I_Error("Could not set DirectSound3D distance factor! (Error code 0x%08x)", hr);
		}

		if(FAILED(hr = IDirectSound3DListener_SetDopplerFactor(g_pDS3DL, 1.0f, DS3D_IMMEDIATE)))
		{
			I_Error("Could not set DirectSound3D doppler factor! (Error code 0x%08x)", hr);
		}

		if(FAILED(hr = IDirectSound3DListener_SetRolloffFactor(g_pDS3DL, 0.005f, DS3D_IMMEDIATE)))
		{
			I_Error("Could not set DirectSound3D rolloff factor! (Error code 0x%08x)", hr);
		}
/*
		if(FAILED(hr = IDirectSound3DListener_SetRolloffFactor(g_pDS3DL, 0.01f, DS3D_IMMEDIATE)))
		{
			I_Error("Could not set DirectSound3D rolloff factor! (Error code 0x%08x)", hr);
		}
*/
	}

	if(debugmode)
	{
		ST_Message("DirectSound initialized properly.");
	}

	// Now, setup MIDI...
	//
	I_InitMusic(g_pDS);

/*
	// initialize dmxCodes[]
  dmxCodes[0] = 0;
  dmxCodes[snd_PC] = AHW_PC_SPEAKER;
  dmxCodes[snd_Adlib] = AHW_ADLIB;
  dmxCodes[snd_SB] = AHW_SOUND_BLASTER;
  dmxCodes[snd_PAS] = AHW_MEDIA_VISION;
  dmxCodes[snd_GUS] = AHW_ULTRA_SOUND;
  dmxCodes[snd_MPU] = AHW_MPU_401;
  dmxCodes[snd_MPU2] = AHW_MPU_401;
  dmxCodes[snd_MPU3] = AHW_MPU_401;
  dmxCodes[snd_AWE] = AHW_AWE32;
  dmxCodes[snd_CDMUSIC] = 0;

  // inits sound library timer stuff
  I_StartupTimer();

  // pick the sound cards i'm going to use
  //
  I_sndArbitrateCards();

  if (debugmode)
  {
	ST_Message("    Music device #%d & dmxCode=%d,", snd_MusicDevice,
	  dmxCodes[snd_MusicDevice]);
	ST_Message(" Sfx device #%d & dmxCode=%d\n", snd_SfxDevice,
	  dmxCodes[snd_SfxDevice]);
  }

  // inits DMX sound library
  ST_Message("    Calling DMX_Init...");
  rc = DMX_Init(SND_TICRATE, SND_MAXSONGS, dmxCodes[snd_MusicDevice],
	dmxCodes[snd_SfxDevice]);

  if (debugmode)
  {
	ST_Message(" DMX_Init() returned %d\n", rc);
  }
*/
}

// shuts down all sound stuff

void I_ShutdownSound (void)
{
	int i, j;

	I_ShutdownMusic();

	if(snd_SfxDevice == snd_none)
	{
		return;
	}

	for(i = 0; i < NUMSFX; i++)
	{
		if(S_sfx[i].rgpDSB)
		{
			for(j = 0; j < MAX_SOUND_COPIES; j++)
			{
				if(S_sfx[i].rgpDSB[j])
				{
					IDirectSoundBuffer_Release(S_sfx[i].rgpDSB[j]);
				}
			}
			free(S_sfx[i].rgpDSB);
			S_sfx[i].rgpDSB = NULL;
		}
	}

	if(g_pDS3DL)
	{
		IDirectSound3DListener_Release(g_pDS3DL);
		g_pDS3DL = NULL;
	}

	if(g_pDS)
	{
		IDirectSound_Release(g_pDS);
		g_pDS = NULL;
	}

/*
	DMX_DeInit();
  I_ShutdownTimer();
*/
}

void I_SetChannels(int channels)
{
//  WAV_PlayMode(channels, SND_SAMPLERATE);
}


#if 0

void WriteShortMIDIMessage(DWORD **ppCurMIDEvent, LONG lWait, BYTE bStatus, BYTE bData1, BYTE bData2)
{
	static BYTE bLastStatus = 0;

	// High bit is now allowed to be set on the first or second data bytes!
	//
	assert(!(bData1 & 0x80) && !(bData2 & 0x80));

	// First DWORD, the dwDeltaTime member...
	//
	(*ppCurMIDEvent)[0] = lWait;

	// Second DWORD, the dwStreamID member...
	//
	(*ppCurMIDEvent)[1] = 0;

	// Third (and final) DWORD, the dwEvent member...
	//
	(*ppCurMIDEvent)[2] = (unsigned)(MEVT_F_SHORT | MEVT_SHORTMSG) << 24;

	if(bStatus != bLastStatus)
	{
		bLastStatus = bStatus;
		(*ppCurMIDEvent)[2] |= (unsigned)(bData2) << 16;
		(*ppCurMIDEvent)[2] |= (unsigned)(bData1) << 8;
		(*ppCurMIDEvent)[2] |= bStatus;
	}
	else
	{
		// (Running status...)
		//
		(*ppCurMIDEvent)[2] |= (unsigned)(bData2) << 8;
		(*ppCurMIDEvent)[2] |= bData1;
	}

	(*ppCurMIDEvent) += 3;
}


void HandleKeyUp(MUSEvent *pevt, MUS2MIDIState *pM2M)
{
	BYTE bChannel = pevt->m_event.m_bChannel;

#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Key %d UP\n", (DWORD)(*(pM2M->m_pCurMUSEvent)));
#endif

	WriteShortMIDIMessage(&pM2M->m_pCurMIDEvent, 
						  pM2M->m_lNextWaitTime, 
						  0x80 | bChannel,
						  *(pM2M->m_pCurMUSEvent),
						  pM2M->m_rgbChannelVolume[bChannel]);

	pM2M->m_pCurMUSEvent += 1;
}


void HandleKeyDown(MUSEvent *pevt, MUS2MIDIState *pM2M)
{
	BYTE bChannel = pevt->m_event.m_bChannel;
	BYTE bKey;
	BYTE bVolume;

	if(*(pM2M->m_pCurMUSEvent) & 0x80)
	{
		// The volume is specified, and will be the next byte.
		// We'll also store this volume as the relevent channel's
		// current volume.
		//
		bKey = *(pM2M->m_pCurMUSEvent) & 0x7F;
		bVolume = *(pM2M->m_pCurMUSEvent + 1);
		pM2M->m_pCurMUSEvent += 2;
		pM2M->m_rgbChannelVolume[bChannel] = bVolume;
#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Key %d DOWN with VOLUME %d\n", (DWORD)bKey, (DWORD)bVolume);
#endif
	}
	else
	{
		// Volume is not specified. Just pull the current volume
		// out of the Channel's current data buffer.
		//
		bKey = *(pM2M->m_pCurMUSEvent);
		bVolume = pM2M->m_rgbChannelVolume[bChannel];
		pM2M->m_pCurMUSEvent += 1;
#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Key %d DOWN\n", (DWORD)bKey);
#endif
	}

	WriteShortMIDIMessage(&pM2M->m_pCurMIDEvent, 
						  pM2M->m_lNextWaitTime, 
						  0x90 | bChannel,
						  bKey,
						  bVolume);
}


void HandlePitchBend(MUSEvent *pevt, MUS2MIDIState *pM2M)
{
	WORD wPitchBend = *(pM2M->m_pCurMUSEvent);

	// In MUS, pitch bend values are 8-bit (0 to 0xFF), with 0x80 being "normal".
	// In MIDI, they are 14-bit (0 to 0x3FFF), with 0x2000 being "normal".
	//
	wPitchBend <<= 6;

#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Pitch-Bend to %d\n", (DWORD)wPitchBend);
#endif

	WriteShortMIDIMessage(&pM2M->m_pCurMIDEvent,
						  pM2M->m_lNextWaitTime,
						  0xE0 | pevt->m_event.m_bChannel,
						  wPitchBend & 0x7F,
						  wPitchBend >> 7);

	pM2M->m_pCurMUSEvent += 1;
}


void HandleSystemEvent(MUSEvent *pevt, MUS2MIDIState *pM2M)
{
	BYTE bData1;

	switch(*(pM2M->m_pCurMUSEvent))
	{
		case 10:
			bData1 = 0x78;
			break;

		case 11:
			bData1 = 0x7B;
			break;

		case 12:
			bData1 = 0x7E;
			break;

		case 13:
			bData1 = 0x7F;
			break;

		case 14:
			bData1 = 0x79;
			break;

		default:
			assert(false);
			break;
	}
#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Valueless controller %d\n", (DWORD)bData1);
#endif

	WriteShortMIDIMessage(&pM2M->m_pCurMIDEvent,
						  pM2M->m_lNextWaitTime,
						  0xB0 | pevt->m_event.m_bChannel,
						  bData1,
						  0);

	pM2M->m_pCurMUSEvent += 1;
}	


void HandleControllerEvent(MUSEvent *pevt, MUS2MIDIState *pM2M)
{
	BYTE bStatus;
	BYTE bData1, bData2;

	if(*(pM2M->m_pCurMUSEvent) == 0)
	{
		bStatus = 0xC0 | pevt->m_event.m_bChannel;
		bData1 = *(pM2M->m_pCurMUSEvent + 1);
		bData2 = 0;
#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Patch Change to %d\n", (DWORD)bData1);
#endif
	}
	else
	{
		bStatus = 0xB0 | pevt->m_event.m_bChannel;
		bData2 = *(pM2M->m_pCurMUSEvent + 1);

		switch(*(pM2M->m_pCurMUSEvent))
		{
			case 1:
				bData1 = 0x00;
				break;

			case 2:
				bData1 = 0x01;
				break;

			case 3:
				bData1 = 0x07;
				break;

			case 4:
				bData1 = 0x0A;
				break;

			case 5:
				bData1 = 0x0B;
				break;

			case 6:
				bData1 = 0x5B;
				break;

			case 7:
				bData1 = 0x5D;
				break;

			case 8:
				bData1 = 0x40;
				break;

			case 9:
				bData1 = 0x43;
				break;

			default:
				assert(false);
				break;
		}

#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation + strlen(pM2M->m_szCurrentOperation), "Controller %d set value %d\n", (DWORD)bData1, (DWORD)bData2);
#endif
	}

	WriteShortMIDIMessage(&pM2M->m_pCurMIDEvent,
						  pM2M->m_lNextWaitTime,
						  bStatus,
						  bData1,
						  bData2);

	pM2M->m_pCurMUSEvent += 2;
}

static DWORD UnpackVariableTimeLength(BYTE **ppBytes)
{
	DWORD dwLength = 0;
	BYTE bCur;
	int i = 0;

	do
	{
		bCur = **ppBytes;
		dwLength <<= 7;
		dwLength |= (bCur & 0x7F);
		i++;
		*ppBytes += 1;
	} while(bCur & 0x80);

	// No length should be more than 4 bytes total. If it is, we must
	// have &*@#!'ed-up somewhere...
	//
	assert(i <= 4);

	return dwLength;
}

void ConvertMUSEventsToMIDIEvents(MUS2MIDIState *pM2M)
{
	while(1)
	{
		MUSEvent evt;

		evt.m_bEvent = *(pM2M->m_pCurMUSEvent);

		// Put MUS channel 15 (its Drum channel) onto
		// channel 9 (GM Drum channel).
		//
		if(evt.m_event.m_bChannel == 15)
		{
			evt.m_event.m_bChannel = 9;
		}
		else if(evt.m_event.m_bChannel == 9)
		{
			evt.m_event.m_bChannel = 15;
		}

#ifdef _DEBUG
		sprintf(pM2M->m_szCurrentOperation, "Channel %ld: ", (DWORD)evt.m_event.m_bChannel);
#endif

		// We advance the MUS pointer in preparation for the function call.
		//
		pM2M->m_pCurMUSEvent += 1;

		switch(evt.m_event.m_bEventType)
		{
			case 0:
				HandleKeyUp(&evt, pM2M);
				break;

			case 1:
				HandleKeyDown(&evt, pM2M);
				break;

			case 2:
				HandlePitchBend(&evt, pM2M);
				break;

			case 3:
				HandleSystemEvent(&evt, pM2M);
				break;

			case 4:
				HandleControllerEvent(&evt, pM2M);
				break;

			case 6:
				return;
				break;

			default:
				assert(false);
				break;
		}

/*
#ifdef _DEBUG
		if(evt.m_event.m_bChannel == 15)
		{
			OutputDebugString(pM2M->m_szCurrentOperation);
		}
#endif
*/
		// Verify we haven't written past our MIDIEVENT array...
		//
		assert(pM2M->m_pCurMIDEvent < pM2M->m_rgmidEvents + pM2M->m_dwcBufferDWORDs);

		// We expect that the function call above advanced the MUS
		// pointer as necessary.
		//
		if(evt.m_event.m_bLast)
		{
			pM2M->m_lNextWaitTime = UnpackVariableTimeLength(&pM2M->m_pCurMUSEvent);
		}
		else
		{
			pM2M->m_lNextWaitTime = 0;
		}
	};
}

#endif